PFont mono;

void draw_toponyms()
{
  textFont(mono);

  for (int i = 0; i < toponym_list.size(); i++)
  {
    float pointSize = map((toponym_list.get(i).count), 0, max, 2, 50);

    pushMatrix();
    float[] rotation = cam.getRotations();
    translate((toponym_list.get(i).x), (toponym_list.get(i).y), (toponym_list.get(i).z));
    rotateX(rotation[0]);
    rotateY(rotation[1]);
    rotateZ(rotation[2]);

    strokeWeight(pointSize);
    if (toponym_list.get(i).count < 10)
    {
      stroke(#C0C0C0);
    }
    else
    {
      stroke(#808080);
    }
    point(0, 0, 0);
    float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
    // draw points
    if (mouseObjectDistance < pointSize) {
      //textSize(16);
      //text(toponym_list.get(i).toponym, 15, 15);
      strokeWeight(75);
      stroke(0, 408, 612);
      point(0, 0, 0);

      popMatrix();
      // highlight the co-occurred toponyms related to the selected toponym
      for (int j = 0; j < toponym_list.get(i).itemsOfToponym.size(); j++)
      {
        Item item = toponym_list.get(i).itemsOfToponym.get(j);
        for (int k = 0; k < item.toponymsOfItem.length; k++)
        {
          for (int p = 0; p < toponym_list.size(); p++)
          {
            if (toponym_list.get(p).toponym == item.toponymsOfItem[k])
            {
              strokeWeight(8);
              stroke(0, 408, 612, 100);
              point(toponym_list.get(p).x, toponym_list.get(p).y, toponym_list.get(p).z);
              // for those 'large' toponym we need to filter out co-occurred toponyms
              if (toponym_list.get(p).count < 50  && toponym_list.get(i).itemsOfToponym.size() > 100)
              {
                break;
              }
              else
              {
                textSize(16);
                fill(0, 0, 0);
                text(toponym_list.get(p).toponym, toponym_list.get(p).x, toponym_list.get(p).y);
                break;
              }
            }
          }
         
        }
      }
    }
    else
    {
      // if you wanna draw anything here
      popMatrix();
    }
    
    
    
    // draw texts
    if (mouseObjectDistance < pointSize) {
      hint(DISABLE_DEPTH_TEST);
      cam.beginHUD();
      cp5.draw();
      textAlign(LEFT);
      translate(0, 25, 0);
      fill(0, 0, 0);
      textSize(20);
      text("Toponym", 35, 280);
      fill(0, 408, 612, 180);
      textSize(18);
      text(toponym_list.get(i).toponym, 35, 300);
      fill(0, 0, 0);
      textSize(14);
      text("Mentioned in "+ Integer.toString(toponym_list.get(i).itemsOfToponym.size()) + " Items ...", 35, 320);
      for (int j = 0; j < toponym_list.get(i).itemsOfToponym.size(); j++)
      {
        Item item = toponym_list.get(i).itemsOfToponym.get(j);
        fill(0, 408, 612, 180);
        textSize(10);
        String title = item.title;
        if (title.length() > 60)
        {
          title = title.substring(0,57) + "...";
        }
        text(title, 35, 320 + (j+1)*20);
        fill(#C0C0C0);
        textSize(8);
        String toponyms = String.join(", ", item.toponymsOfItem);
        if (toponyms.length() > 60)
        {
          toponyms = toponyms.substring(0,57) + "...";
        }
        text(toponyms, 35, 328 + (j+1)*20);
      }
      cam.endHUD();
      hint(ENABLE_DEPTH_TEST);
    }
  }
}

void draw_items()
{
 
  textFont(mono);

  for (int i = 0; i < item_list.size(); i++)
  {
    String[] toponymsOfItem = item_list.get(i).toponymsOfItem;
    ArrayList <Place> toponymsOfItem_geoEnriched = new ArrayList<Place>();
    for (int j = 0; j < toponymsOfItem.length; j++)
    {
      String toponym = toponymsOfItem[j];
      float x;
      float y;
      float z;
      for (int k = 0; k < toponym_list.size(); k++)
      {
        Place currentPlace = toponym_list.get(k);
        if (currentPlace.toponym == toponym)
        {
          x = currentPlace.x;
          y = currentPlace.y;
          z = currentPlace.z;
          toponymsOfItem_geoEnriched.add(new Place(toponym, x, y, z));
          break;
        }
      }
    }
    if (toponymsOfItem_geoEnriched.size() <= 2)
    {
      continue;
    }
    noFill();
    beginShape();
    stroke(#C0C0C0);
    for (int j = 0; j < toponymsOfItem_geoEnriched.size(); j++)
    {
      Place toponymOfItem = toponymsOfItem_geoEnriched.get(j);
      curveVertex(toponymOfItem.x, toponymOfItem.y, toponymOfItem.z);
      if ((j == 0) || (j == toponymsOfItem_geoEnriched.size()-1))
      {
        curveVertex(toponymOfItem.x, toponymOfItem.y, toponymOfItem.z);
      }
    }
    endShape();
  }
}

void draw_project_info()
{
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();

  textFont(mono);

  textAlign(LEFT);
  pushMatrix();
  translate(0, 25, 0);
  textSize(28);
  fill(0, 0, 0);
  text("Place Names in the Semantic Space", 35, 30);
  textSize(16);
  fill(0, 408, 612, 180);
  text("Seattle Public Library, Geography & History, Toponym Recognition", 35, 60);
  textSize(12);
  fill(0, 408, 612, 120);
  text("MAT 259 | Winter 2022 | Zilong Liu", 35, 100);  
  textSize(14);
  fill(0, 0, 0);
  text("Hover over a toponym to see its co-occurred toponyms\nalong with the mentioned items.", 1450, 960);
  //fill(0, 0, 0);
  //text("Press X to turn on the x-axis.", 1500, 1000);
  //fill(0, 0, 0);
  //text("Press Y to turn on the y-axis.", 1500, 1020);
  //fill(0, 0, 0);
  //text("Press A or D to rotate horizontally.", 1500, 1000);
  //fill(0, 0, 0);
  //text("Press W or S to rotate vertically.", 1500, 1020);
  popMatrix();

  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);

  stroke(#808080, 50);
  strokeWeight(1);
  noFill();
  sphere(300);

}

void legend()
{
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  textSize(16);
  text("Point Size v.s. Number of Associated Items", 1500, 400);
  for (int i = 10 + int((max-10)/50)*10*2; i < max; i += int((max-10)/50)*10)
  {
    float pointSize = map(i, 0, max, 2, 50);
    strokeWeight(pointSize);
    stroke(#808080);
    point(1700, 400 + pointSize + int(i/10) - 100, 0);
    textSize(16);
    text(Integer.toString(i), 1750, 400 + pointSize + int(i/10) - 100);
  }
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void draw_x_axis()
{
  rotateX(PI/2);
  noFill();
  strokeWeight(2);
  circle(0, 0, 600);
}

void draw_y_axis()
{
  rotateY(PI/2);
  noFill();
  strokeWeight(2);
  circle(0, 0, 600);
}
