/*************************************************************************************
Data Visualization - Place Names Extracted from Geograph-Related Items in Seattle Public 
                     Library 
Tested in Processing 4.0b3                                    
                                                     
Author: Zilong Liu                                       

References: Parts of the codes were developed based upon Language Learning Interest 
            at Seattle Public Library (by Meilin Shi from Winter 2019).

Usage: 1. To show how toponyms extracted from the subject of each item are distributed 
          in the semantic space.
*************************************************************************************/
import peasy.*;
import controlP5.*;
import java.util.*;

PeasyCam cam;
ControlP5 cp5;
void setup()
{
  fullScreen(P3D);
  cam = new PeasyCam(this,600);
  cp5 = new ControlP5(this);
  readQueryResult();
  mono = loadFont("courier.vlw");
}

void draw()
{
  background(255);
  rotateX(-PI/6);
  rotateY(PI/6);

  textMode(SHAPE);
  colorMode(HSB);

  draw_project_info();
  draw_toponyms();
  legend();

  if (drawX)
  {
    draw_x_axis();
  }
  if (drawY)
  {
    draw_y_axis();
  }
}
