Table item_table;
ArrayList <Item> item_list = new ArrayList<Item>();
ArrayList <Place> toponym_list = new ArrayList<Place>();
HashMap <String, ArrayList <Item>> mapOfToponyms = new HashMap<String, ArrayList <Item>>();
float r = 300; 
int max = 0;

// read the query result (after toponym recognition) and preprocess it
void readQueryResult()
{
    item_table = loadTable("../3d_query_result_2016_ner.csv","header");

    for (int i = 0; i < item_table.getRowCount(); i++)
    {
        int bibNumber = item_table.getInt(i,1);
        float deweyClass = item_table.getFloat(i,2);
        String title = item_table.getString(i,3);
        String subject = item_table.getString(i,4);
        String itemType = item_table.getString(i,5);
        String toponyms = item_table.getString(i,6);

        if (toponyms == "")
        {
            continue;
        }

        String[] toponymsOfItem = toponyms.split("\t");

        Item itemToAdd = new Item(bibNumber, deweyClass, title, subject, itemType, toponymsOfItem);
        item_list.add(itemToAdd);

        for (int j = 0; j < toponymsOfItem.length; j++)
        {
            ArrayList <Item> itemsOfToponym = mapOfToponyms.getOrDefault(toponymsOfItem[j], new ArrayList<Item>());
            itemsOfToponym.add(itemToAdd);
            mapOfToponyms.put(toponymsOfItem[j],itemsOfToponym);
        }
    }

    for (HashMap.Entry<String, ArrayList <Item>> toponym_entry : mapOfToponyms.entrySet())
    {
        float x = random(-(r-10), r-10); 
        float y = random(-sqrt((sq(r)-sq(x))), sqrt((sq(r)-sq(x)))); 
        float z = random(-sqrt((sq(r)-sq(x)-sq(y))), sqrt((sq(r)-sq(x)-sq(y))));
        String toponym = toponym_entry.getKey();
        ArrayList <Item> itemsOfToponym = toponym_entry.getValue();
        int count = itemsOfToponym.size();
        if (count > max)
        {
            max = count;
        }
        toponym_list.add(new Place(toponym, x, y, z, count, itemsOfToponym));
    }
  HashSet<Place> toponym_set = new HashSet<Place>(toponym_list);
  toponym_list = new ArrayList<Place>(toponym_set);
  
}
