# -*- coding: utf-8 -*-
"""
Created on Sat Feb  5 19:05:01 2022

@author: Zilong Liu
"""

import spacy
import pandas as pd
import numpy as np

## the function to extract toponyms
def extract_toponym(text):
    toponym_list = []
    nlp_result = nlp(str(text))
    for result in nlp_result.ents:
        if (result.label_ in [u"GPE", u"FACILITY", u"LOC", u"FAC", u"LOCATION"]):
            toponym_list.append(result.text)
    return '\t'.join(np.unique(np.array(toponym_list)))
            
## load the pre-trained English pipeline
nlp = spacy.load("en_core_web_lg")

## read query result
df_spl = pd.read_csv('3d_query_result_2016.csv')
## df_spl = df_spl.head(5000)

## extract toponyms from both subject
df_spl['toponyms_subject'] = df_spl['subject'].apply(lambda text:extract_toponym(text))

## output dataframe to csv
df_spl.to_csv('3d_query_result_2016_ner.csv')